// si_Basecode.cpp - space invaders opengl 0.6.0

/***********************************************
*                                              *
*    Jeff Molofee's Revised OpenGL Basecode    *
*  Huge Thanks To Maxwell Sayles & Peter Puck  *
*            http:// nehe.gamedev.net          *
*                     2001                     *
*                                              *
***********************************************/

#define _CRT_SECURE_NO_WARNINGS			// For 4996 warning
#include <windows.h>					// Header File For The Windows Library
#include <Wininet.h>					// Header File For Internet Library
#include <gl/gl.h>						// Header File For The OpenGL32 Library
#include <gl/glu.h>						// Header File For The OpenGL Utility Library
#include "si_Basecode.h"				// Header File For The NeHeGL Basecode
#include "si_Main.h"					// Header File For Main Global Variables
#include "commctrl.h"					// Header File For Windows XP Common Controls
#include "si_Functions.h"

#define WM_TOGGLEFULLSCREEN (WM_USER+1)	// Application Define Message For Toggling Fullscreen

// ALPHA LAYERED WINDOW (POUR LA TRANSPARENCE DE FENETRE WINDOWS)
typedef BOOL (WINAPI *SLWA_FUNC)(HWND hwnd,COLORREF crKey,BYTE bAlpha,DWORD dwFlags);
//bool first_pass = true;
//DWORD start;
//DWORD actual;
//BYTE alpha=0;

// DIVERS
bool			equalizer_moving = false;						// Equalizer en train d're dlac?
bool			dialogbox_internet_over = false;				// Bouton Internet (mouse over)
extern bool		game_spectrum;									// Spectrum activ?
HWND			Dlghwnd;										// Main DialogBox Handle (global variable)
HWND			AboutDlghwnd;									// About DialogBox Handle (global variable)
HCURSOR			cur_hand, cur_hand_closed;						// Cursors

// PARAMETRES DE JEU (STEP, LOADING)
extern int		game_step;										// Etape du jeu (chargement etc.)
extern bool		Fps2_firstpass;									// FPS Mhode n2
bool			game_loading			= false;				// To make thread Loading called only once
bool			game_loading_finished	= true;

// THREADS
unsigned long	h_thread2;										// Thread Loading
bool			my_mod_about_on = false;						// Music For About-DialogBox
bool			my_mod_about_working = false;					// Music For About-DialogBox

// PROGRAMME
static BOOL		g_isProgramLooping;								// Window Creation Loop, For FullScreen/Windowed Toggle																		// Between Fullscreen / Windowed Mode
static BOOL		g_createFullScreen;								// If TRUE, Then Create Fullscreen
GL_Window		window;											// Window Structure

// TERMINE L'APPLICATION
void TerminateApplication(GL_Window* window)					// Terminate The Application
{
	PostMessage(window->hWnd, WM_QUIT, 0, 0);					// Send A WM_QUIT Message
	g_isProgramLooping = FALSE;									// Stop Looping Of The Program
}

// BASCULE FULLSCREEN / FENETRE
void ToggleFullscreen(GL_Window* window)						// Toggle Fullscreen/Windowed
{
	PostMessage(window->hWnd, WM_TOGGLEFULLSCREEN, 0, 0);		// Send A WM_TOGGLEFULLSCREEN Message
}

// REPLACE LA CAMERA
void ReshapeGL(int width, int height)							// Reshape The Window When It's Moved Or Resized
{
	extern float ciblex, cibley, zoom_total;
	glViewport(0, 0, (GLsizei)(width), (GLsizei)(height));		// Reset The Current Viewport
	glMatrixMode(GL_PROJECTION);								// Select The Projection Matrix
	glLoadIdentity();											// Reset The Projection Matrix
	gluPerspective(45.0f, (GLfloat)(width)/ (GLfloat)(height),	// Calculate The Aspect Ratio Of The Window
					0.1f, 500.0f);

	pcamera.x = pcamera.y = ciblex = cibley = zoom_total = 0;
	pcamera.z = 20;

	!game_3d ? angle_y = 0 : angle_y = -40;						// si pas game_3d angle_y=0 sinon angle_y=40
	!game_3d ? player[0].y = -6.15 : player[0].y = -7.00;		// si pas game_3d ...
	
	angle_x = 0;

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(	pcamera.x, pcamera.y, pcamera.z,				// la cama
				ciblex, cibley, 0,								// la cible
				0.0, 1.0,  0.0	);								// le haut
}

// CHANGE LA RESOLUTION
BOOL ChangeScreenResolution(int width, int height, int bitsPerPixel)	// Change The Screen Resolution
{
	DEVMODE dmScreenSettings;									// Device Mode
	ZeroMemory(&dmScreenSettings, sizeof(DEVMODE));				// Make Sure Memory Is Cleared
	dmScreenSettings.dmSize				= sizeof(DEVMODE);		// Size Of The Devmode Structure
	dmScreenSettings.dmPelsWidth		= width;				// Select Screen Width
	dmScreenSettings.dmPelsHeight		= height;				// Select Screen Height
	dmScreenSettings.dmBitsPerPel		= bitsPerPixel;			// Select Bits Per Pixel
	dmScreenSettings.dmFields			= DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;
	if (ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
	{
		return FALSE;											// Display Change Failed, Return False
	}
	return TRUE;												// Display Change Was Successful, Return True
}

void fullscreen(void)
{
	// fenre
	//DWORD windowStyle = WS_OVERLAPPEDWINDOW;					// Define Our Window Style
	//DWORD windowExtendedStyle = WS_EX_APPWINDOW;				// Define The Window's Extended Style

	// fullscreen
	DWORD windowStyle = WS_POPUP;								// Set The WindowStyle To WS_POPUP (Popup Window)
	DWORD windowExtendedStyle = WS_EX_TOPMOST;					// Set The Extended Window Style To WS_EX_TOPMOST


	// retrieve the resolution
	HWND	hDesktop = GetDesktopWindow();
	HDC	hDc = GetDC(hDesktop);
	int w = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, HORZRES);
	int h = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, VERTRES);
	int bits = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, BITSPIXEL);
	ReleaseDC(hDesktop, hDc);
	
	// change style
	DWORD dwStyle,dwNewStyle;
	
	dwStyle = GetWindowLong(g_window->hWnd, (TRUE ? GWL_EXSTYLE : GWL_STYLE));
	//dwNewStyle = (dwStyle & (~NULL)) | windowExtendedStyle;
	//dwStyle = GetWindowLong(g_window->hWnd, GWL_EXSTYLE);
	dwNewStyle = (dwStyle & (~NULL)) | windowExtendedStyle;
	
	SetWindowLong(g_window->hWnd, (TRUE ? GWL_EXSTYLE : GWL_STYLE), dwNewStyle);
	//SetWindowPos(g_window->hWnd,NULL,0,0,w,h,SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE);
	//SetWindowLong(g_window->hWnd, GWL_EXSTYLE, dwNewStyle);
	SetWindowPos(g_window->hWnd,NULL,0,0,w,h,SWP_NOZORDER);

}

//	RETOURNE LA TAILLE DU BUREAU
void ReturnSystemMetrics(int *Width, int *Height, int *BitsPerPixel)
{
	HWND	hDesktop = GetDesktopWindow();
	HDC	hDc = GetDC(hDesktop);

	*(Width) = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, HORZRES);
	*(Height) = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, VERTRES);
	*(BitsPerPixel) = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, BITSPIXEL);
	ReleaseDC(hDesktop, hDc);

	return;
	// une autre mhode : HEIGHT = GetSystemMetrics(SM_CYSCREEN); WIDTH = GetSystemMetrics(SM_CXSCREEN);
}

//////////////////////////////////////////////////////////////////////////////////////
//
// DANS UN NOUVEAU THREAD - ESSAYE DE SE CONNECTER A INTERNET POUR DECLENCHER LA CONNEXION
//                          INTERNET ET EVENTUELLEMENT LE FIREWALL
//
void InternetConnect(void* dummy)
{
	static bool already_tried = false;
	if (already_tried) return;

	InternetAttemptConnect(0);
	HINTERNET my_internet = InternetOpen("Microsoft Internet Explorer", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, NULL);
	if (InternetOpenUrl(my_internet, "http://www.google.com", NULL, NULL, NULL, NULL) == NULL)
	{
		if (GetLastError() == ERROR_INTERNET_EXTENDED_ERROR)
		{
			char buf[2000];
			DWORD e, l=sizeof (buf);
			InternetGetLastResponseInfo (&e, buf, &l);
			MessageBox(Dlghwnd, buf, "Internet Error", MB_APPLMODAL);
		}
		else
			MessageBox(Dlghwnd, "Info : Internet connection can't be used.", "Warning", MB_APPLMODAL);
	}

	already_tried = true;
	_endthread();
}

//////////////////////////////////////////////////////////////////////////////////////
//
// CREATE WINDOW GL
//
//
BOOL CreateWindowGL(GL_Window* window)						// This Code Creates Our OpenGL Window
{
	DWORD windowStyle = WS_OVERLAPPEDWINDOW;				// Define Our Window Style
	DWORD windowExtendedStyle = WS_EX_APPWINDOW;			// Define The Window's Extended Style

	PIXELFORMATDESCRIPTOR pfd =								// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),						// Size Of This Pixel Format Descriptor
			1,												// Version Number
			PFD_DRAW_TO_WINDOW |							// Format Must Support Window
			PFD_SUPPORT_OPENGL |							// Format Must Support OpenGL
			PFD_DOUBLEBUFFER,								// Must Support Double Buffering
			PFD_TYPE_RGBA,									// Request An RGBA Format
			window->init.bitsPerPixel,						// Select Our Color Depth
			0, 0, 0, 0, 0, 0,								// Color Bits Ignored
			0,												// No Alpha Buffer
			0,												// Shift Bit Ignored
			0,												// No Accumulation Buffer
			0, 0, 0, 0,										// Accumulation Bits Ignored
			16,												// 16Bit Z-Buffer (Depth Buffer)  
			0,												// No Stencil Buffer
			0,												// No Auxiliary Buffer
			PFD_MAIN_PLANE,									// Main Drawing Layer
			0,												// Reserved
			0, 0, 0											// Layer Masks Ignored
	};
	RECT windowRect = {0, 0, window->init.width, window->init.height};	// Define Our Window Coordinates

	GLuint PixelFormat;										// Will Hold The Selected Pixel Format

	if (window->init.isFullScreen == TRUE)					// Fullscreen Requested, Try Changing Video Modes
	{
		if (ChangeScreenResolution(window->init.width, window->init.height, window->init.bitsPerPixel) == FALSE)
		{
			MessageBox(HWND_DESKTOP, "Mode Switch Failed.\nRunning In Windowed Mode.", "Error", MB_OK | MB_ICONEXCLAMATION);
			window->init.isFullScreen = FALSE;				// Set isFullscreen To False (Windowed Mode)
		}
		else												// Otherwise (If Fullscreen Mode Was Successful)
		{
			ShowCursor(TRUE);								// Turn Off The Cursor
			windowStyle = WS_POPUP;							// Set The WindowStyle To WS_POPUP (Popup Window)
			windowExtendedStyle |= WS_EX_TOPMOST;			// Set The Extended Window Style To WS_EX_TOPMOST
		}													// (Top Window Covering Everything Else)
	}
	else if (window->init.quickFullScreen == TRUE) 
	{
		ShowCursor(TRUE);									// Turn Off The Cursor
		windowStyle = WS_POPUP;								// Set The WindowStyle To WS_POPUP (Popup Window)
		windowExtendedStyle |= WS_EX_TOPMOST;				// Set The Extended Window Style To WS_EX_TOPMOST
	}														// (Top Window Covering Everything Else)
	else													// If Fullscreen Was Not Selected
	{
		AdjustWindowRectEx(&windowRect, windowStyle, 0, windowExtendedStyle);	// Adjust Window, Account For Window Borders
	}

	// On centre la fenre si on est en mode window
	int left_shift = 0;
	int top_shift  = 0;

	if (!window->init.isFullScreen && !window->init.quickFullScreen)
	{
		HWND	hDesktop = GetDesktopWindow();
		HDC	hDc = GetDC(hDesktop);
		int desktop_width  = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, HORZRES);
		int desktop_height = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, VERTRES);
		ReleaseDC(hDesktop, hDc);

		if (window->init.width < desktop_width && window->init.height < desktop_height)	// on ne centre que si la fenre est + petite que le bureau
		{
			left_shift =  desktop_width  / 2 - window->init.width  / 2;
			top_shift  =  desktop_height / 2 - window->init.height / 2 - 40;
		}
	}

	// Create The OpenGL Window
	window->hWnd = CreateWindowEx(windowExtendedStyle,		// Extended Style
		window->init.application->className,				// Class Name
		window->init.title,									// Window Title
		windowStyle,										// Window Style
		left_shift, top_shift,								// Window X,Y Position
		windowRect.right - windowRect.left,					// Window Width
		windowRect.bottom - windowRect.top,					// Window Height
		HWND_DESKTOP,										// Desktop Is Window's Parent
		0,													// No Menu
		window->init.application->hInstance,				// Pass The Window Instance
		window);

	if (window->hWnd == 0)									// Was Window Creation A Success?
	{
		return FALSE;										// If Not Return False
	}

	window->hDC = GetDC(window->hWnd);						// Grab A Device Context For This Window
	if (window->hDC == 0)									// Did We Get A Device Context?
	{
		// Failed
		DestroyWindow(window->hWnd);						// Destroy The Window
		window->hWnd = 0;									// Zero The Window Handle
		return FALSE;										// Return False
	}
	
	//
	// Anti-aliasing (FSAA)
	//
	// Our first pass, Multisampling hasn't been created yet, so we create a window normally
	// If it is supported, then we're on our second pass
	// that means we want to use our pixel format for sampling
	// so set PixelFormat to arbMultiSampleformat instead

	if(!arbMultisampleSupported)
	{
		PixelFormat = ChoosePixelFormat (window->hDC, &pfd);	// Find A Compatible Pixel Format
		if (PixelFormat == 0)									// Did We Find A Compatible Format?
		{
			// Failed
			ReleaseDC (window->hWnd, window->hDC);				// Release Our Device Context
			window->hDC = 0;									// Zero The Device Context
			DestroyWindow (window->hWnd);						// Destroy The Window
			window->hWnd = 0;									// Zero The Window Handle
			return FALSE;										// Return False
		}
	}
	else
	{
		PixelFormat = arbMultisampleFormat;
	}

	if (SetPixelFormat (window->hDC, PixelFormat, &pfd) == FALSE)	// Try To Set The Pixel Format
	{
		// Failed
		ReleaseDC (window->hWnd, window->hDC);					// Release Our Device Context
		window->hDC = 0;										// Zero The Device Context
		DestroyWindow (window->hWnd);							// Destroy The Window
		window->hWnd = 0;										// Zero The Window Handle
		return FALSE;											// Return False
	}

	window->hRC = wglCreateContext (window->hDC);				// Try To Get A Rendering Context
	if (window->hRC == 0)										// Did We Get A Rendering Context?
	{
		// Failed
		ReleaseDC (window->hWnd, window->hDC);					// Release Our Device Context
		window->hDC = 0;										// Zero The Device Context
		DestroyWindow (window->hWnd);							// Destroy The Window
		window->hWnd = 0;										// Zero The Window Handle
		return FALSE;											// Return False
	}

	// Make The Rendering Context Our Current Rendering Context
	if (wglMakeCurrent (window->hDC, window->hRC) == FALSE)
	{
		// Failed
		wglDeleteContext (window->hRC);							// Delete The Rendering Context
		window->hRC = 0;										// Zero The Rendering Context
		ReleaseDC (window->hWnd, window->hDC);					// Release Our Device Context
		window->hDC = 0;										// Zero The Device Context
		DestroyWindow (window->hWnd);							// Destroy The Window
		window->hWnd = 0;										// Zero The Window Handle
		return FALSE;											// Return False
	}

	/*
	Now that our window is created, we want to query what samples are available
	we call our InitMultiSample window
	if we return a valid context, we want to destroy our current window
	and create a new one using the multisample interface.
	*/
	if(!arbMultisampleSupported && CHECK_FOR_MULTISAMPLE)
	{
		if(InitMultisample(window->init.application->hInstance,window->hWnd,pfd))
		{
			// Anti-aliasing disponible
			DestroyWindowGL (window);		// on druit la fenre actuelle,
			return CreateWindowGL(window);	// et on relance la fonction dans laquelle
											// on se trouve pour recrr une nouvelle
											// fenre avec l'interface multisample !
		}
	}

	glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_FASTEST);	

	ShowWindow(window->hWnd, SW_NORMAL);						// Make The Window Visible
	window->isVisible = TRUE;									// Set isVisible To True

	ReshapeGL(window->init.width, window->init.height);			// Reshape Our GL Window

	ZeroMemory(window->keys, sizeof(Keys));						// Clear All Keys

	window->lastTickCount = GetTickCount();						// Get Tick Count

	return TRUE;												// Window Creating Was A Success
	// Initialization Will Be Done In WM_CREATE
}

//////////////////////////////////////////////////////////////////////////////////////
//
// DESTROY WINDOW GL
//
//
BOOL DestroyWindowGL(GL_Window* window)							// Destroy The OpenGL Window & Release Resources
{
	if (window->hWnd != 0)										// Does The Window Have A Handle?
	{	
		if (window->hDC != 0)									// Does The Window Have A Device Context?
		{
			wglMakeCurrent(window->hDC, 0);						// Set The Current Active Rendering Context To Zero
			if (window->hRC != 0)								// Does The Window Have A Rendering Context?
			{
				wglDeleteContext(window->hRC);					// Release The Rendering Context
				window->hRC = 0;								// Zero The Rendering Context
			}
			ReleaseDC(window->hWnd, window->hDC);				// Release The Device Context
			window->hDC = 0;									// Zero The Device Context
		}
		DestroyWindow(window->hWnd);							// Destroy The Window
		window->hWnd = 0;										// Zero The Window Handle
	}

	if (window->init.isFullScreen)								// Is Window In Fullscreen Mode
	{
		ChangeDisplaySettings(NULL, 0);							// Switch Back To Desktop Resolution
		ShowCursor(TRUE);										// Show The Cursor
	}	
	return TRUE;												// Return True
}

//////////////////////////////////////////////////////////////////////////////////////
//
// Process Window Message Callbacks
//
//
LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	// Get The Window Context
	GL_Window* window = (GL_Window*)(GetWindowLong(hWnd, GWL_USERDATA));

	switch (uMsg)												// Evaluate Window Message
	{
	case WM_SYSCOMMAND:											// Intercept System Commands
		{
			switch (wParam)										// Check System Calls
			{
				case SC_SCREENSAVE:								// Screensaver Trying To Start?
				case SC_MONITORPOWER:							// Monitor Trying To Enter Powersave?
					return 0;									// Prevent From Happening
			}
			break;												// Exit
		}
		return 0;												// Return

	case WM_CREATE:												// Window Creation
		{
			CREATESTRUCT* creation = (CREATESTRUCT*)(lParam);	// Store Window Structure Pointer
			window = (GL_Window*)(creation->lpCreateParams);
			SetWindowLong(hWnd, GWL_USERDATA, (LONG)(window));
		}
		return 0;												// Return

	case WM_CLOSE:												// Closing The Window
		TerminateApplication(window);							// Terminate The Application
		return 0;												// Return

	case WM_ENTERSIZEMOVE:
		if (game_step == 2)										// pendant le chargement on baisse la priorit
			SetThreadPriority((void*)h_thread2, THREAD_PRIORITY_LOWEST);
		return 0;

	case WM_EXITSIZEMOVE:
		{
			if (game_step == 2)									// pendant le chargement on remet en haute priorit
				SetThreadPriority((void*)h_thread2, THREAD_PRIORITY_NORMAL );
			else
				SetThreadPriority((void*)h_thread2, THREAD_PRIORITY_NORMAL );
			Fps_Reinitialize();									// FPS Mhode n1 - To Avoid Jump Movement After Resize / Move
			Fps2_firstpass = true;								// FPS Mhode n2
		}
		return 0;

	case WM_SIZE:												// Size Action Has Taken Place
		switch (wParam)											// Evaluate Size Action
		{
		case SIZE_MINIMIZED:									// Was Window Minimized?
			window->isVisible = FALSE;							// Set isVisible To False
			return 0;											// Return

		case SIZE_MAXIMIZED:									// Was Window Maximized?
			window->isVisible = TRUE;							// Set isVisible To True
			ReshapeGL(LOWORD(lParam), HIWORD(lParam));			// Reshape Window - LoWord=Width, HiWord=Height
			window->init.width = LOWORD(lParam);
			window->init.height = HIWORD(lParam);
			Fps_Reinitialize();									// FPS Mhode n1
			Fps2_firstpass = true;								// FPS Mhode n2
			return 0;											// Return

		case SIZE_RESTORED:										// Was Window Restored?
			window->isVisible = TRUE;							// Set isVisible To True
			ReshapeGL(LOWORD(lParam), HIWORD(lParam));			// Reshape Window - LoWord=Width, HiWord=Height
			window->init.width = LOWORD(lParam);
			window->init.height = HIWORD(lParam);
			Fps_Reinitialize();									// FPS Mhode n1
			Fps2_firstpass = true;								// FPS Mhode n2
			return 0;											// Return
		}
		break;													// Break

	case WM_KEYDOWN:											// Update Keyboard Buffers For Keys Pressed
		if ((wParam >= 0) && (wParam <= 255))					// Is Key (wParam) In A Valid Range?
		{
			window->keys->keyDown[wParam] = TRUE;				// Set The Selected Key (wParam) To True
			TCHAR temp[512];
			wsprintf(temp,"%d",wParam);
			//OutputDebugString(temp);							// Pour savoir le code d'une Touch press
			return 0;											// Return
		}
		break;													// Break

	case WM_KEYUP:												// Update Keyboard Buffers For Keys Released
		if ((wParam >= 0) && (wParam <= 255))					// Is Key (wParam) In A Valid Range?
		{
			window->keys->keyDown[wParam] = FALSE;				// Set The Selected Key (wParam) To False
			return 0;											// Return
		}
		break;													// Break

	case WM_LBUTTONDOWN:
		{
			if (game_step != 4) return 0;
			moving = true;										// We are moving the scene
			startx = LOWORD(lParam);							// mouse x
			starty = HIWORD(lParam);							// mouse y

			// largeur de rolution
			int w = g_window->init.width;

			// paliers de rolutions
			int w2;
			if (w >= 1600) w2 = 1600; else if (w >= 1280) w2 = 1280; else if (w >= 1024) w2 = 1024;	else if (w >= 800) w2 = 800; else w2 = 640;
		
			// dlacement equalizer (BOUTON ENFON)
			if (game_spectrum && w > 550)
				if ((startx > equalizer_x+w+(-184)*w2/1024 && startx < equalizer_x+w+(-184+147)*w2/1024)
				&& (starty > -equalizer_y+(+238-102)*w2/1024 && starty < -equalizer_y+238*w2/1024))
				{
					equalizer_moving = true;					// l'equalizer est boug
					SetCursor(cur_hand_closed);
				}
		}
		break;

	case WM_LBUTTONUP:
		{
			// dplacement equalizer (BOUTON RELACH)
			if (equalizer_moving)
				SetCursor(cur_hand);

			moving = false;										// We stop moving the scene
			equalizer_moving = false;							// We stop moving the equalizer
		}
		break;

	case WM_MOUSEMOVE:
		{
			if (game_step != 4) return 0;

			// largeur de rolution
			int w = g_window->init.width;

			// paliers de rolutions
			int w2;
			if (w >= 1600) w2 = 1600; else if (w >= 1280) w2 = 1280; else if (w >= 1024) w2 = 1024;	else if (w >= 800) w2 = 800; else w2 = 640;
		
			// equalizer (MOUSE OVER)
			if (game_spectrum && w > 550)
				if ((startx > equalizer_x+w+(-184)*w2/1024 && startx < equalizer_x+w+(-184+147)*w2/1024)
				&& (starty > -equalizer_y+(+238-102)*w2/1024 && starty < -equalizer_y+238*w2/1024))
					if (equalizer_moving)
						SetCursor(cur_hand_closed);
					else
						SetCursor(cur_hand);
		
			// dlacement equalizer (la souris est dlac pendant que le bouton est press
			if (equalizer_moving)
			{
				equalizer_x += LOWORD(lParam) - startx;
				equalizer_y += starty - HIWORD(lParam);
			}
			// rotation de la sce (bouton enfon mais pas sur l'ualizer)
			else if (moving)
			{
				angle_x += (LOWORD(lParam) - startx) / 2;		// souris axe x (/2 => moins rapide)
				angle_y += (HIWORD(lParam) - starty) / 2;		// souris axe y (/2 => moins rapide)
			}
			startx = LOWORD(lParam);							// mouse x
			starty = HIWORD(lParam);							// mouse y
		}
		break;

	case WM_TOGGLEFULLSCREEN:									// Toggle FullScreen Mode On/Off
		g_createFullScreen = (g_createFullScreen == TRUE) ? FALSE : TRUE;
		PostMessage(hWnd, WM_QUIT, 0, 0);
		break;													// Break

	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);			// Pass Unhandled Messages To DefWindowProc
}

//////////////////////////////////////////////////////////////////////////////////////
//
// REGISTER WINDOW CLASS
//
//
BOOL RegisterWindowClass(Application* application)				// Register A Window Class For This Application.
{																// TRUE If Successful
	// Register A Window Class
	WNDCLASSEX windowClass;										// Window Class
	ZeroMemory(&windowClass, sizeof(WNDCLASSEX));				// Make Sure Memory Is Cleared
	windowClass.cbSize			= sizeof(WNDCLASSEX);			// Size Of The windowClass Structure
	windowClass.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraws The Window For Any Movement / Resizing
	windowClass.lpfnWndProc		= (WNDPROC)(WindowProc);		// WindowProc Handles Messages
	windowClass.hInstance		= application->hInstance;		// Set The Instance
	windowClass.hbrBackground	= static_cast<HBRUSH>(GetStockObject(BLACK_BRUSH));// Class Background Brush Color
	windowClass.hCursor			= LoadCursor(application->hInstance, (LPCTSTR)IDC_CURSOR_CROSS);// Load The Arrow Pointer
	windowClass.lpszClassName	= application->className;		// Sets The Applications Classname
	windowClass.hIcon			= LoadIcon(application->hInstance, (LPCTSTR)IDI_ICON_APP);

	if (RegisterClassEx(&windowClass) == 0)						// Did Registering The Class Fail?
	{
		// NOTE: Failure, Should Never Happen
		MessageBox(HWND_DESKTOP, "RegisterClassEx Failed!", "Error", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;											// Return False (Failure)
	}
	return TRUE;												// Return True (Success)
}


//////////////////////////////////////////////////////////////////////////////////////
//
// THREAD - ON BAISSE LE VOLUME DE LA MUSIQUE
//
//
void FmodFadingOut(void* dummy)
{
	int volume = 250;
	DWORD time0 = timeGetTime();
	DWORD time1 = timeGetTime();

	do
	{
		if ((time1 - time0) >= 10)
		{
			volume -= 5;
			FMUSIC_SetMasterVolume(my_mod_about,volume);
			time0 = timeGetTime();
			time1 = timeGetTime();
		}

		Sleep(10);

		time1 = timeGetTime();
	}
	while(volume >= 0);

	FMUSIC_StopSong(my_mod_about);
	my_mod_about_on = false;
	my_mod_about_working = false;
	_endthread();
}

//////////////////////////////////////////////////////////////////////////////////////
//
// THREAD - ON AUGMENTE LE VOLUME DE LA MUSIQUE
//
//
void FmodFadingIn(void* dummy)
{
	FMUSIC_SetMasterVolume(my_mod_about, 0);

	if (!FMUSIC_IsPlaying(my_mod_about))
		FMUSIC_PlaySong(my_mod_about);

	my_mod_about_on = true;
	int volume = 0;
	DWORD time0 = timeGetTime();
	DWORD time1 = timeGetTime();

	do
	{
		if ((time1 - time0) >= 10)
		{
			volume += 5;
			FMUSIC_SetMasterVolume(my_mod_about,volume);
			time0 = timeGetTime();
			time1 = timeGetTime();
		}

		Sleep(10);

		time1 = timeGetTime();
	}
	while(volume <= 250);

	my_mod_about_working = false;
	_endthread();
}

//////////////////////////////////////////////////////////////////////////////////////
//
// THREAD - TRANSPARENCE DE LA FENETRE (WIN 2000/XP)
//
//
void dialog_transparency(void* dummy)
{
	Sleep(250);
	int alpha = 0;
	DWORD dwStyle = GetWindowLong(AboutDlghwnd, GWL_EXSTYLE);
	SetWindowLong(AboutDlghwnd, GWL_EXSTYLE, dwStyle | 0x00080000);	// = WS_EX_LAYERED

	#define LWA_ALPHA		0x00000002
	SLWA_FUNC MySetLayeredWindowAttributes;
	HMODULE hUser32 = GetModuleHandle("USER32.DLL");
	if (!hUser32) _endthread();
	MySetLayeredWindowAttributes = (SLWA_FUNC)GetProcAddress(hUser32,"SetLayeredWindowAttributes");

	do
	{
		if (MySetLayeredWindowAttributes)
			MySetLayeredWindowAttributes(AboutDlghwnd,NULL,alpha,LWA_ALPHA);

		alpha += 30;
		Sleep(2);
	}
	while(alpha <= 255);

	// retour au mode normal
	if (MySetLayeredWindowAttributes)
		MySetLayeredWindowAttributes(AboutDlghwnd,NULL,255,LWA_ALPHA);
	SetWindowLong(AboutDlghwnd,GWL_EXSTYLE,dwStyle & ~0x80000);

	_endthread();
}

//////////////////////////////////////////////////////////////////////////////////////
//
// CALLBACK - DIALOG BOX ABOUT (FICHIER README, ETC.)
//
//
BOOL CALLBACK ScreenAboutDlgProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
	AboutDlghwnd = hwndDlg;									// Global about dialogbox handle
	static HWND edit_handle = NULL;

	switch (message) 
	{ 
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		case IDCANCEL:				// hidden button (called automatically when the escape key is pressed)
		case IDC_BUTTON_CLOSE:
			SendMessage(hwndDlg, WM_CLOSE, 0, 0);
			return TRUE;
		case IDC_BUTTON_MUTE:
			{
				if (!my_mod_about_working)
				{
					my_mod_about_working = true;

					if (FMUSIC_IsPlaying(my_mod_about))
					{
						// place l'ice "MUSIQUE ON" dans le bouton
						HICON hU = (HICON)LoadImage(window.init.application->hInstance,	MAKEINTRESOURCE(IDB_BUTTON_PLAY), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
						SendMessage(GetDlgItem(hwndDlg,IDC_BUTTON_MUTE), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM) (DWORD) hU );

						_beginthread( FmodFadingOut, 0, NULL );
					}
					else
					{
						// place l'ice "MUSIQUE OFF" dans le bouton
						HICON hU = (HICON)LoadImage(window.init.application->hInstance,	MAKEINTRESOURCE(IDB_BUTTON_MUTE), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
						SendMessage(GetDlgItem(hwndDlg,IDC_BUTTON_MUTE), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM) (DWORD) hU );

						_beginthread( FmodFadingIn, 0, NULL );
					}
				}
			}
			break;

		case IDC_HOMEPAGE:
			ShellExecute(hwndDlg, "open", "http://spaceinvadersgl.sourceforge.net", NULL, NULL, SW_SHOWNORMAL);
			return TRUE;

		case IDC_MAIL:
			ShellExecute(hwndDlg, "open", "mailto:maya75@users.sourceforge.net", NULL, NULL, SW_SHOWNORMAL);
			return TRUE;
		}
		switch (HIWORD(wParam))
		{
		case BN_CLICKED:
			break;
		}
		break;

	case WM_CLOSE:	// Closing The Window

		FMUSIC_StopSong(my_mod_about);
		my_mod_about_on = false;
		my_mod_about_working = false;

		EndDialog(hwndDlg, TRUE);
		break;

	case WM_INITDIALOG:
		{
			//// FADING TRANSPARENCE
			//// on met l'opacit0
			//DWORD dwStyle = GetWindowLong(hwndDlg, GWL_EXSTYLE);
			//SetWindowLong(hwndDlg, (TRUE ? GWL_EXSTYLE : GWL_STYLE), dwStyle | 0x00080000);
			//#define LWA_ALPHA		0x00000002
			//SLWA_FUNC MySetLayeredWindowAttributes;
			//HMODULE hUser32 = GetModuleHandle("USER32.DLL");
			//if (hUser32)
			//{
			//	MySetLayeredWindowAttributes = (SLWA_FUNC)GetProcAddress(hUser32,"SetLayeredWindowAttributes");
			//	if (MySetLayeredWindowAttributes)
			//		MySetLayeredWindowAttributes(hwndDlg,NULL,0,LWA_ALPHA);
			//}
			//// on lance le thread qui augmente l'opacit
			//_beginthread( dialog_transparency, 0, NULL );

			// HYPERLIENS
			ConvertStaticToHyperlink(hwndDlg, IDC_HOMEPAGE);
			ConvertStaticToHyperlink(hwndDlg, IDC_MAIL);

			// EDIT BOX (fichier readme.txt)
			edit_handle = CreateWindowEx(
				WS_EX_CLIENTEDGE,
				"EDIT",
				NULL,
				WS_CHILD | WS_VSCROLL | ES_AUTOHSCROLL |  ES_AUTOVSCROLL | ES_LEFT | ES_MULTILINE | ES_WANTRETURN,
				10, 50,
				553, 347,
				hwndDlg,
				NULL,
				(HINSTANCE)GetWindowLong(hwndDlg, GWL_HINSTANCE),
				NULL);

			if(edit_handle == NULL)
				MessageBox(NULL, "Could not create edit control!", "Error", MB_OK | MB_ICONERROR);

			// on cr la nouvelle font
			HFONT t_font = CreateFont(12, 0, 0, 0, FW_NORMAL, false, false, false, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, 12, "Lucida Console");
			SendMessage(edit_handle, WM_SETFONT, (WPARAM)t_font, MAKELONG(true, 0));

			// on remplit l'Edit Box par le texte du fichier Readme.txt
			HRSRC hrsrc			= FindResource(0, MAKEINTRESOURCE(IDR_README_TXT), "TEXT");
			HGLOBAL resource	= LoadResource(0, hrsrc);
			void* buffer		= LockResource(resource);
			unsigned int size	= SizeofResource(NULL, hrsrc);
			char* my_text		= (char*)buffer;
			UnlockResource(resource);
			FreeResource(resource);

			SendMessage(edit_handle, WM_SETTEXT, NULL, (LPARAM)my_text);
			ShowWindow(edit_handle, SW_SHOW);

			// MUSIQUE
			if (!my_mod_about)
			{

				fmod_extract ();								// not to be removed

				if (!FSOUND_Init(44100, 32, 0))
				{
					MessageBox(0, FMOD_ErrorString(FSOUND_GetError()), "Sound Initialization Error", MB_TOPMOST);
					FSOUND_Close();
				}

				HRSRC res					= FindResource(NULL, MAKEINTRESOURCE(IDR_SOUND_XM_ABOUT), "WAVE");
				HGLOBAL hres				= LoadResource(NULL, res);
				void * data					= LockResource(hres);
				unsigned long int length	= SizeofResource(NULL, res);

				if (!(my_mod_about = FMUSIC_LoadSongEx((const char*)data, 0, length, FSOUND_LOADMEMORY, NULL, 0)))
					FMOD_ErrorString(FSOUND_GetError());

				UnlockResource(hres);
				FreeResource(hres);

				my_mod_about_working = true;
				_beginthread( FmodFadingIn, 0, NULL );
				my_mod_about_on = true;
			}

			// BOUTON (musique on/off)
			if (my_mod_about_on)
			{
				// place l'ice "MUSIQUE OFF" dans le bouton
				HICON hU = (HICON)LoadImage(window.init.application->hInstance,	MAKEINTRESOURCE(IDB_BUTTON_MUTE), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
				SendMessage(GetDlgItem(hwndDlg,IDC_BUTTON_MUTE), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM) (DWORD) hU );
			}
			else
			{
				// place l'ice "MUSIQUE ON" dans le bouton
				HICON hU = (HICON)LoadImage(window.init.application->hInstance,	MAKEINTRESOURCE(IDB_BUTTON_PLAY), IMAGE_BITMAP, 0, 0, LR_DEFAULTCOLOR);
				SendMessage(GetDlgItem(hwndDlg,IDC_BUTTON_MUTE), BM_SETIMAGE, IMAGE_BITMAP, (LPARAM) (DWORD) hU );
			}

			break;
		}

		/*
		// transparence de fenre windows mettre dans WM_PAINT (voir)

		case WM_CREATE:
		{
		// Transparence de la fenre
		// on ajoute le style WS_EX_LAYERED	(0x00080000) la DialogBox

		DWORD dwStyle,dwNewStyle;

		dwStyle = GetWindowLong(hwndDlg, (TRUE ? GWL_EXSTYLE : GWL_STYLE));
		dwNewStyle = (dwStyle & (~NULL)) | 0x00080000;
		SetWindowLong(hwndDlg, (TRUE ? GWL_EXSTYLE : GWL_STYLE), dwNewStyle);
		SetWindowPos(hwndDlg,NULL,0,0,0,0,SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE);

		// puis on rle l'alpha
		#define WS_EX_LAYERED	0x00080000
		#define LWA_COLORKEY	0x00000001
		#define LWA_ALPHA		0x00000002
		BYTE alpha=200,Anim=1;

		SLWA_FUNC MySetLayeredWindowAttributes;
		HMODULE hUser32 = GetModuleHandle("USER32.DLL");
		if (!hUser32) return FALSE;
		MySetLayeredWindowAttributes = (SLWA_FUNC)GetProcAddress(hUser32,"SetLayeredWindowAttributes");
		if (MySetLayeredWindowAttributes)
		MySetLayeredWindowAttributes(hwndDlg,NULL,alpha,LWA_ALPHA);

		}*/
	} 
	return FALSE; 
} 

//////////////////////////////////////////////////////////////////////////////////////
//
// CALLBACK - DIALOG BOX PRINCIPALE (FENETRE DE DEMARRAGE)
//
//
BOOL CALLBACK ScreenDlgProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
	
	Dlghwnd = hwndDlg;										// Global main dialogbox handle

	switch (message)
	{ 
	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{ 
		case IDC_BUTTON_ABOUT:
			DialogBox(window.init.application->hInstance, MAKEINTRESOURCE(IDD_DIALOG_ABOUT), hwndDlg, (DLGPROC)ScreenAboutDlgProc);
			break;

		case IDCANCEL:			// hidden button (called automatically when the escape key is pressed)
			FMUSIC_SetMasterVolume(my_mod_about,0);
			FMUSIC_StopSong(my_mod_about);
			FMUSIC_FreeSong(my_mod_about);
			FSOUND_Close();

			EndDialog(hwndDlg, TRUE);
			exit(0);
			break;

		case IDC_STREAM:
			game_option_stream = !game_option_stream;				// Internet Audio streaming
			EnableWindow( GetDlgItem(hwndDlg,IDC_BITRATE), game_option_stream );
			_beginthread( InternetConnect, 0, NULL );
			break;

		case IDC_BITRATE:
				game_option_bitrate = SendMessage(GetDlgItem(hwndDlg,IDC_BITRATE), CB_GETCURSEL, 0, 0);
			break;

		case IDOK: 
			if (!IsDlgButtonChecked(hwndDlg, IDC_FULLSCREEN))
				window.init.isFullScreen = FALSE;					// If Not, Run In Windowed Mode 

			if (IsDlgButtonChecked(hwndDlg, IDC_QUICK_FULLSCREEN))
				window.init.quickFullScreen = TRUE;					// Quick fullscreen
			else
				window.init.quickFullScreen = FALSE;

			if (IsDlgButtonChecked(hwndDlg, IDC_16BPP))
				window.init.bitsPerPixel	= 16;					// Bits Per Pixel 				
			else
				window.init.bitsPerPixel	= 32;					// Bits Per Pixel

			if (IsDlgButtonChecked(hwndDlg, IDC_640_480))
			{
				window.init.width			= 640;					// Window Width
				window.init.height			= 480;					// Window Height
			}
			else
			{
				if (IsDlgButtonChecked(hwndDlg, IDC_800_600))
				{
					window.init.width		= 800;					// Window Width
					window.init.height		= 600;					// Window Height
				}
				else
				{
					window.init.width		= 1024;					// Window Width
					window.init.height		= 768;					// Window Height
				}
			}

			if (IsDlgButtonChecked(hwndDlg, IDC_MIPMAP))
				game_option_mipmap = true;

			if (IsDlgButtonChecked(hwndDlg, IDC_VSYNC))
				game_option_vsync = true;

			if (IsDlgButtonChecked(hwndDlg, IDC_BILLBOARDING))
				game_option_billboard = true;

			if (IsDlgButtonChecked(hwndDlg, IDC_ANTI_ALIASING))
			{
				game_option_anti_aliasing = true;
				game_fsaa = true;
			}

			EndDialog(hwndDlg, wParam); 
			return TRUE; 
		}
		switch (HIWORD(wParam))
		{
		case BN_CLICKED:
			{
				if (IsDlgButtonChecked(hwndDlg, IDC_FULLSCREEN) || IsDlgButtonChecked(hwndDlg, IDC_WINDOW))
				{
					EnableWindow( GetDlgItem(hwndDlg,IDC_640_480) , TRUE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_800_600) , TRUE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_1024_768), TRUE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_16BPP)   , TRUE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_32BPP)   , TRUE );
				}
				else if (IsDlgButtonChecked(hwndDlg, IDC_QUICK_FULLSCREEN))
				{
					EnableWindow( GetDlgItem(hwndDlg,IDC_640_480) , FALSE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_800_600) , FALSE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_1024_768), FALSE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_16BPP)   , FALSE );
					EnableWindow( GetDlgItem(hwndDlg,IDC_32BPP)   , FALSE );
				}
			}
			break;
		} 
		break;

	case WM_MOUSEMOVE:
		{
			int xPos = LOWORD(lParam);  // horizontal position of cursor 
			int yPos = HIWORD(lParam);  // vertical position of cursor 

			if (xPos>5 && xPos<26 && yPos>94 && yPos<217 && !dialogbox_internet_over)
			{
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET), FALSE);
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET_OVER), TRUE);
				dialogbox_internet_over = true;
				SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(32649))); // Hand cursor
			}
			else if (xPos>5 && xPos<26 && yPos>94 && yPos<217)
				SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(32649))); // Hand cursor
			else if (dialogbox_internet_over)
			{
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET), TRUE);
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET_OVER), FALSE);
				dialogbox_internet_over = false;
			}
		}
		break;

	case WM_LBUTTONDOWN:
		{
			int xPos = LOWORD(lParam);  // horizontal position of cursor 
			int yPos = HIWORD(lParam);  // vertical position of cursor 

			if (xPos>5 && xPos<26 && yPos>94 && yPos<217)
			{
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET), TRUE);
				ShowWindow( GetDlgItem(hwndDlg,IDB_STARTUP_INTERNET_OVER), FALSE);
				SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(32649))); // Hand cursor
			}
			else
				// Drag window by clicking anywhere on it
				PostMessage(hwndDlg, WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM( xPos, yPos));
			break;
		}

	case WM_LBUTTONUP:
		{
			int xPos = LOWORD(lParam);  // horizontal position of cursor 
			int yPos = HIWORD(lParam);  // vertical position of cursor 

			if (xPos>5 && xPos<26 && yPos>94 && yPos<217)
			{
				SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(32649))); // Hand cursor
				ShellExecute(NULL, "open", "http://spaceinvadersgl.sf.net", NULL, NULL, SW_SHOWNORMAL);
			}
		}
		break;

	case WM_CLOSE:
		{
			EndDialog(hwndDlg, TRUE);
			exit(0);
		}

	case WM_INITDIALOG:
		{
			// ASSOCIE UNE ICNE A LA "WINDOW CLASS" DE LA DIALOGBOX
			// (POUR AFFICHAGE LORS DE <ALT>+<TAB> ET PETITE ICNE
			// EN HAUT  GAUCHE DE CETTE FENTRE ET DE SES FILLES)
			SetClassLong (hwndDlg, GCL_HICON, (LONG)LoadIcon (window.init.application->hInstance, MAKEINTRESOURCE (IDI_ICON_APP)));
			
			// INITIALISATION DES CONTROLES (BOUTONS RADIO, CHECKBOX)
			CheckRadioButton(hwndDlg, IDC_QUICK_FULLSCREEN, IDC_WINDOW, IDC_QUICK_FULLSCREEN);
			CheckRadioButton(hwndDlg, IDC_640_480, IDC_1024_768, IDC_640_480);
			CheckRadioButton(hwndDlg, IDC_16BPP, IDC_32BPP, IDC_16BPP);

			CheckDlgButton(hwndDlg, IDC_MIPMAP, BST_CHECKED);
			CheckDlgButton(hwndDlg, IDC_VSYNC, BST_CHECKED);
			CheckDlgButton(hwndDlg, IDC_BILLBOARDING, BST_CHECKED);
			CheckDlgButton(hwndDlg, IDC_ANTI_ALIASING, BST_CHECKED);

			SendMessage(GetDlgItem(hwndDlg,IDC_BITRATE), CB_ADDSTRING, 0, (LPARAM) "DSL");
			SendMessage(GetDlgItem(hwndDlg,IDC_BITRATE), CB_ADDSTRING, 0, (LPARAM) "ISDN");
			SendMessage(GetDlgItem(hwndDlg,IDC_BITRATE), CB_ADDSTRING, 0, (LPARAM) "Dialup");
			SendMessage(GetDlgItem(hwndDlg,IDC_BITRATE), CB_SETCURSEL, 0, 0);

			// CREATION DES TOOLTIPS (INFOS BULLES SUR LES CONTROLES)
			HWND hwndTT = CreateWindowEx(0, TOOLTIPS_CLASS, (LPSTR) NULL,
				TTS_ALWAYSTIP, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				CW_USEDEFAULT, hwndDlg, (HMENU) NULL, window.init.application->hInstance, NULL);

			TOOLINFO ti;
			ti.cbSize = sizeof(TOOLINFO);
			ti.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
			ti.hwnd = hwndDlg;
			ti.hinst = window.init.application->hInstance;

			SendMessage(hwndTT, (UINT) TTM_SETMAXTIPWIDTH, 0, (LPARAM) (INT) 200);		// make multiline tooltips with (LPARAM) (int) width

			ti.uId = (UINT)GetDlgItem(hwndDlg, IDC_MIPMAP);
			ti.lpszText = "MIPMAP TEXTURES :\r\nCreates different size textures for best visual quality.\r\nNeeds a few more memory megabytes.";
			SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);

			ti.uId = (UINT)GetDlgItem(hwndDlg, IDC_VSYNC);
			ti.lpszText = "VERTICAL SYNCHRONIZATION :\r\nAdjusts frame rate to screen frequency for smoothed movements.\r\nFPS is limited by this frequency.";
			SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);

			ti.uId = (UINT)GetDlgItem(hwndDlg, IDC_STREAM);
			ti.lpszText = "STREAMED MUSIC :\r\nEnables Internet music streaming.\r\nChoose from :\r\n- Cable/DSL (128k)\r\n- (Dual)ISDN (56k)\r\n- Dialup (24k)";
			SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);

			ti.uId = (UINT)GetDlgItem(hwndDlg, IDC_BILLBOARDING);
			ti.lpszText = "BILLBOARDING :\r\nAdjusts the orientation of 2D objects (like particles) so they face the camera for best representation (only in 3D mode).\r\nNeeds more CPU.";
			SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);

			ti.uId = (UINT)GetDlgItem(hwndDlg, IDC_ANTI_ALIASING);
			ti.lpszText = "ANTI-ALIASING :\r\nEnables Anti-aliasing, mainly for 3D objects for best visual quality.\r\nNeeds a compatible graphic card and more CPU / graphic card RAM.";
			SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);

			Fps_Init();
		}
			break;
	} 
			return false; 
} 

//////////////////////////////////////////////////////////////////////////////////////
//
// PROGRAM ENTRY (WINMAIN)
//
//
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	Application			application;									// Application Structure"
	Keys				keys;											// Key Structure
	BOOL				isMessagePumpActive;							// Message Pump Active?
	MSG					msg;											// Window Message Structure

	// FMOD ex-DLL INITIALISATION
#ifndef CONFIG_FMOD_EXTRACT_YES
	//FMOD_DllMain(GetModuleHandle(NULL), DLL_PROCESS_ATTACH, NULL);
#endif

	// Fill Out Application Data
	application.className = "OpenGL";				// Application Class Name
	application.hInstance = hInstance;				// Application Instance

	// Fill Out Window
	ZeroMemory(&window, sizeof(GL_Window));			// Make Sure Memory Is Zeroed
	window.keys					= &keys;			// Window Key Structure
	window.init.application		= &application;		// Window Application
	window.init.title			= "Space Invaders OpenGL by Iwanami";	// Window Title
	window.init.width			= 640;				// Default Window Width (modified by startup screen)
	window.init.height			= 480;				// Default Window Height (modified by startup screen)
	window.init.bitsPerPixel	= 16;				// Default Bits Per Pixel (modified by startup screen)
	window.init.isFullScreen	= TRUE;				// Default Fullscreen? (Set To TRUE)
	window.init.quickFullScreen	= TRUE;				// Default quickFullscreen? (Set To TRUE)

	ZeroMemory(&keys, sizeof(Keys));				// Zero keys Structure

	InitCommonControls();							// Initialize Windows XP Common Controls

	// Register A Class For Our Window To Use
	if (RegisterWindowClass(&application) == FALSE)	// Did Registering A Class Fail?
	{
		// Failure
		MessageBox(HWND_DESKTOP, "Error Registering Window Class!", "Error", MB_OK | MB_ICONEXCLAMATION);
		return -1;									// Terminate Application
	}

	//if (IsCardAccelerated())
	//	MessageBox(0,"carte graphique ok","",0);

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_SCREENDLG),	// Runs the Dialog Box
		HWND_DESKTOP, (DLGPROC)ScreenDlgProc); 

	OutputDebugString("Space Invaders OpenGL [Start]");

	if (window.init.quickFullScreen == TRUE && window.init.isFullScreen == FALSE)// If Quick Fullscreen, we catch the screen resolution
	{
		HWND	hDesktop = GetDesktopWindow();
		HDC	hDc = GetDC(hDesktop);
		window.init.width = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, HORZRES);
		window.init.height = GetDeviceCaps(hDc, PLANES) * GetDeviceCaps(hDc, VERTRES);
		ReleaseDC(hDesktop, hDc);
	}

	g_isProgramLooping = TRUE;							// Program Looping Is Set To TRUE
	g_createFullScreen = window.init.isFullScreen;		// g_createFullScreen Is Set To User Default
	
	cur_hand		= LoadCursor(application.hInstance, MAKEINTRESOURCE(IDC_CURSOR_HAND));
	cur_hand_closed	= LoadCursor(application.hInstance, MAKEINTRESOURCE(IDC_CURSOR_HAND_CLOSED));

	while (g_isProgramLooping)							// Loop Until WM_QUIT Is Received
	{
		// Create A Window
		window.init.isFullScreen = g_createFullScreen;	// Set Init Param Of Window Creation To Fullscreen?
		if (CreateWindowGL(&window) == TRUE)			// Was Window Creation Successful?
		{
			// At This Point We Should Have A Window That Is Setup To Render OpenGL
			if (Initialize(&window, &keys) == FALSE)	// Call User Intialization
			{
				// Failure
				TerminateApplication(&window);			// Close Window, This Will Handle The Shutdown
			}
			else										// Otherwise (Start The Message Pump)
			{	// Initialize was a success
				isMessagePumpActive = TRUE;				// Set isMessagePumpActive To TRUE

				DWORD time0 = GetTickCount();

				while (isMessagePumpActive == TRUE)		// While The Message Pump Is Active
				{
					// Success Creating Window.  Check For Window Messages
					if (PeekMessage(&msg, window.hWnd, 0, 0, PM_REMOVE) != 0)
					{
						// Check For WM_QUIT Message
						if (msg.message != WM_QUIT)		// Is The Message A WM_QUIT Message?
						{
							DispatchMessage(&msg);		// If Not, Dispatch The Message
						}								// to WindowProc()
						else							// Otherwise (If Message Is WM_QUIT)
						{
							isMessagePumpActive = FALSE;	// Terminate The Message Pump
						}
					}
					else								// If There Are No Messages
					{
						if (window.isVisible == FALSE)	// If Window Is Not Visible
						{
							WaitMessage();				// Application Is Minimized Wait For A Message (paused)
						}
						else							// If Window Is Visible
						{
							static char debugprint[300]="";
							static int loop=0;

							// ETAPES DU JEU (parties 1,2 et 3 du chargement puis le jeu)

							switch (game_step)
							{
							case 1:
								{
									loading_display1();		// Screen fading In
									Update(0, &window);		// Update
								}
								break;

							case 2:
								{
									if (!game_loading)
									{
										// CREATION D'UN THREAD POUR LE CHARGEMENT
										wglMakeCurrent (NULL, NULL);
										h_thread2 = _beginthread( loading, 0, NULL );
										game_loading = true;
									}

									Sleep(1);				// To avoid making too loops while the loading thread is working,
															// but permit to handle messages (move/close window)
															// => 400 loops against 2,500,000 on my pc !

									Update(0, &window);		// Update
								}
								break;

							case 3:
								{
									loading_display3();		// Screen fading Out
									Update(0, &window);		// Update
								}
								break;

							case 4:
								{
									Fps_Update();
	
									Update(0, &window);		// Update
									GameLogic(&window);		// Game Logic
									Draw(&window);			// Draw
								}									
								break;
							}

							if (game_step != 2)				// game_step function (loading) has its own swapbuffers
								SwapBuffers(window.hDC);	// Swap Buffers (Double Buffering)
						}
					}
				}											// Loop While isMessagePumpActive == TRUE
			}												// If (Initialize (...

			// Application Is Finished
			Deinitialize();									// User Defined DeInitialization

			DestroyWindowGL(&window);						// Destroy The Active Window
		}
		else												// If Window Creation Failed
		{
			// Error Creating Window
			MessageBox(HWND_DESKTOP, "Error Creating OpenGL Window", "Error", MB_OK | MB_ICONEXCLAMATION);
			g_isProgramLooping = FALSE;						// Terminate The Loop
		}
	}														// While (isProgramLooping)

	UnregisterClass(application.className, application.hInstance);	// UnRegister Window Class
	return 0;
}															// End Of WinMain()
