// si_Basecode.h - space invaders opengl

#ifndef _BASECODE_H
#define _BASECODE_H

//////////////////////////////////////////////////////////////////////////////////////
//
// BASECODE => Application, fentre, etc
//
//

typedef struct {									// Structure For Keyboard Stuff
	BOOL keyDown [256];								// Holds TRUE / FALSE For Each Key
} Keys;												// Keys

typedef struct {									// Contains Information Vital To Applications
	HINSTANCE		hInstance;						// Application Instance
	const char*		className;						// Application ClassName
} Application;										// Application

typedef struct {									// Window Creation Info
	Application*		application;				// Application Structure
	char*				title;						// Window Title
	int					width;						// Width
	int					height;						// Height
	int					bitsPerPixel;				// Bits Per Pixel
	BOOL				isFullScreen;				// FullScreen?
	BOOL				quickFullScreen;			// quickFullScreen?
} GL_WindowInit;									// GL_WindowInit

typedef struct {									// Contains Information Vital To A Window
	Keys*				keys;						// Key Structure
	HWND				hWnd;						// Window Handle
	HDC					hDC;						// Device Context
	HGLRC				hRC;						// Rendering Context
	GL_WindowInit		init;						// Window Init
	BOOL				isVisible;					// Window Visible?
	DWORD				lastTickCount;				// Tick Counter
} GL_Window;										// GL_Window

//////////////////////////////////////////////////////////////////////////////////////
//
// BASECODE => Fonctions
//
//

void TerminateApplication (GL_Window* window);		// Terminate The Application
void ToggleFullscreen (GL_Window* window);			// Toggle Fullscreen / Windowed Mode

// FONCTIONS PRINCIPALES
BOOL Initialize (GL_Window* window, Keys* keys);	// Performs All Your Initialization
void Deinitialize (void);							// Performs All Your DeInitialization
void Update (DWORD milliseconds, GL_Window* window);// Perform Motion Updates
void Draw (GL_Window* window);						// Perform All Your Scene Drawing
void GameLogic (GL_Window* window);					// Perform Game Logic

// SCENE ROTATION
extern bool moving; 
extern double startx, starty;						// Rotation l'aide de la souris
extern double angle_y;
extern double angle_x;		                        // The Current Position Of The Mouse

// CHARGEMENT
void loading (void *dummy);							// CHARGEMENT DES ELEMENTS
void loading_display1 (void);						// CHARGEMENT => FADING IN
void loading_display2 (void);						// CHARGEMENT => LOG SYSTEM
void loading_display3 (void);						// CHARGEMENT => FADING OUT

// FENETRAGE
void ReshapeGL (int width, int height);
BOOL ChangeScreenResolution(int width, int height, int bitsPerPixel);
BOOL DestroyWindowGL(GL_Window* window);
void ReturnSystemMetrics(int *Width, int *Height, int *BitsPerPixel);
void fullscreen(void);
void dialog_transparency(void *dummy);

#endif												// _BASECODE_H
